/*
 * Demonstrate Windows API error handling
 *
 * (c) 2006, Bernhard Rabe
 */

#include <windows.h>
#include <stdio.h>

void printErrorAndExit(const char *msg, DWORD err)
{
	LPSTR lpMsgBuf;
	if(FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|
			          FORMAT_MESSAGE_FROM_SYSTEM | 
					  FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						err,
					  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
					  (LPTSTR) &lpMsgBuf,
					  0,
					  NULL ))
	{
		fprintf(stderr,"%s : %s\n",msg,lpMsgBuf);
		LocalFree(lpMsgBuf);
	}
	else
	{
		fprintf(stderr,"Error at FormatMesage: %d\n",err=GetLastError());
	}
	exit(err);
}


int main(int argc, char *argv[])
{
    
    if(argc>1)
    {
            PROCESS_INFORMATION pi;
            STARTUPINFO  si;
            ZeroMemory(&pi,sizeof(pi));
            ZeroMemory(&si,sizeof(si));
            si.cb=sizeof(si);
            
            if(!CreateProcess(NULL,argv[1],NULL,NULL,FALSE,0,NULL,NULL,&si,&pi))
            {
                return printErrorAndExit("CreateProcess",GetLastError());
            }
    }
    else
    {
        printf("usage: %s program-executable\n",argv[0]);
    }
    return 0;
}